diff --git a/drivers/bus/auxiliary/auxiliary_common.c b/drivers/bus/auxiliary/auxiliary_common.c
index 38d722e653..259ff152c4 100644
--- a/drivers/bus/auxiliary/auxiliary_common.c
+++ b/drivers/bus/auxiliary/auxiliary_common.c
@@ -23,7 +23,6 @@
 #include <rte_devargs.h>
 
 #include "private.h"
-#include "rte_bus_auxiliary.h"
 
 static struct rte_devargs *
 auxiliary_devargs_lookup(const char *name)
diff --git a/drivers/bus/auxiliary/auxiliary_params.c b/drivers/bus/auxiliary/auxiliary_params.c
index 542083dc89..a889e392c6 100644
--- a/drivers/bus/auxiliary/auxiliary_params.c
+++ b/drivers/bus/auxiliary/auxiliary_params.c
@@ -10,7 +10,6 @@
 #include <rte_kvargs.h>
 
 #include "private.h"
-#include "rte_bus_auxiliary.h"
 
 enum auxiliary_params {
 	RTE_AUXILIARY_PARAM_NAME,
diff --git a/drivers/bus/auxiliary/rte_bus_auxiliary.h b/drivers/bus/auxiliary/bus_auxiliary_driver.h
similarity index 94%
rename from drivers/bus/auxiliary/rte_bus_auxiliary.h
rename to drivers/bus/auxiliary/bus_auxiliary_driver.h
index 3b3dbc866a..44bacc3c0e 100644
--- a/drivers/bus/auxiliary/rte_bus_auxiliary.h
+++ b/drivers/bus/auxiliary/bus_auxiliary_driver.h
@@ -22,6 +22,7 @@ extern "C" {
 #include <stdint.h>
 #include <inttypes.h>
 
+#include <rte_compat.h>
 #include <rte_debug.h>
 #include <rte_interrupts.h>
 #include <rte_dev.h>
@@ -41,7 +42,7 @@ struct rte_auxiliary_device;
  * @return
  *   Whether the driver can handle the auxiliary device.
  */
-typedef bool(rte_auxiliary_match_t)(const char *name);
+typedef bool (rte_auxiliary_match_t)(const char *name);
 
 /**
  * Initialization function for the driver called during auxiliary probing.
@@ -54,8 +55,8 @@ typedef bool(rte_auxiliary_match_t)(const char *name);
  *   - 0 On success.
  *   - Negative value and rte_errno is set otherwise.
  */
-typedef int(rte_auxiliary_probe_t)(struct rte_auxiliary_driver *drv,
-				    struct rte_auxiliary_device *dev);
+typedef int (rte_auxiliary_probe_t)(struct rte_auxiliary_driver *drv,
+	struct rte_auxiliary_device *dev);
 
 /**
  * Uninitialization function for the driver called during hotplugging.
@@ -85,7 +86,7 @@ typedef int (rte_auxiliary_remove_t)(struct rte_auxiliary_device *dev);
  *   - Negative value and rte_errno is set otherwise.
  */
 typedef int (rte_auxiliary_dma_map_t)(struct rte_auxiliary_device *dev,
-				       void *addr, uint64_t iova, size_t len);
+	void *addr, uint64_t iova, size_t len);
 
 /**
  * Driver-specific DMA un-mapping. After a successful call the device
@@ -104,7 +105,7 @@ typedef int (rte_auxiliary_dma_map_t)(struct rte_auxiliary_device *dev,
  *   - Negative value and rte_errno is set otherwise.
  */
 typedef int (rte_auxiliary_dma_unmap_t)(struct rte_auxiliary_device *dev,
-					 void *addr, uint64_t iova, size_t len);
+	void *addr, uint64_t iova, size_t len);
 
 /**
  * A structure describing an auxiliary device.
@@ -157,7 +158,7 @@ struct rte_auxiliary_driver {
  *   A pointer to a rte_auxiliary_driver structure describing the driver
  *   to be registered.
  */
-__rte_experimental
+__rte_internal
 void rte_auxiliary_register(struct rte_auxiliary_driver *driver);
 
 /** Helper for auxiliary device registration from driver instance */
@@ -179,7 +180,7 @@ void rte_auxiliary_register(struct rte_auxiliary_driver *driver);
  *   A pointer to a rte_auxiliary_driver structure describing the driver
  *   to be unregistered.
  */
-__rte_experimental
+__rte_internal
 void rte_auxiliary_unregister(struct rte_auxiliary_driver *driver);
 
 #ifdef __cplusplus
diff --git a/drivers/bus/auxiliary/linux/auxiliary.c b/drivers/bus/auxiliary/linux/auxiliary.c
index 28092e31c4..d4c564cd78 100644
--- a/drivers/bus/auxiliary/linux/auxiliary.c
+++ b/drivers/bus/auxiliary/linux/auxiliary.c
@@ -11,7 +11,6 @@
 #include <rte_memcpy.h>
 #include <eal_filesystem.h>
 
-#include "../rte_bus_auxiliary.h"
 #include "../private.h"
 
 #define AUXILIARY_SYSFS_PATH "/sys/bus/auxiliary/devices"
diff --git a/drivers/bus/auxiliary/meson.build b/drivers/bus/auxiliary/meson.build
index e2b356f8d2..fcb1a349c4 100644
--- a/drivers/bus/auxiliary/meson.build
+++ b/drivers/bus/auxiliary/meson.build
@@ -1,9 +1,7 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright (c) 2021 NVIDIA Corporation & Affiliates
 
-headers = files(
-        'rte_bus_auxiliary.h',
-)
+driver_sdk_headers += files('bus_auxiliary_driver.h')
 sources = files(
         'auxiliary_common.c',
         'auxiliary_params.c',
diff --git a/drivers/bus/auxiliary/private.h b/drivers/bus/auxiliary/private.h
index 1e0e584039..3dee13e1d1 100644
--- a/drivers/bus/auxiliary/private.h
+++ b/drivers/bus/auxiliary/private.h
@@ -11,7 +11,7 @@
 
 #include <bus_driver.h>
 
-#include "rte_bus_auxiliary.h"
+#include "bus_auxiliary_driver.h"
 
 extern int auxiliary_bus_logtype;
 
diff --git a/drivers/bus/auxiliary/version.map b/drivers/bus/auxiliary/version.map
index dc993e84ff..e9322e0b11 100644
--- a/drivers/bus/auxiliary/version.map
+++ b/drivers/bus/auxiliary/version.map
@@ -1,7 +1,6 @@
-EXPERIMENTAL {
+INTERNAL {
 	global:
 
-	# added in 21.08
 	rte_auxiliary_register;
 	rte_auxiliary_unregister;
 
diff --git a/drivers/common/mlx5/linux/mlx5_common_auxiliary.c b/drivers/common/mlx5/linux/mlx5_common_auxiliary.c
index a182a8bdde..33479ffd68 100644
--- a/drivers/common/mlx5/linux/mlx5_common_auxiliary.c
+++ b/drivers/common/mlx5/linux/mlx5_common_auxiliary.c
@@ -8,7 +8,7 @@
 
 #include <rte_malloc.h>
 #include <rte_errno.h>
-#include <rte_bus_auxiliary.h>
+#include <bus_auxiliary_driver.h>
 #include <rte_common.h>
 #include "eal_filesystem.h"
 
diff --git a/drivers/common/mlx5/linux/mlx5_common_os.c b/drivers/common/mlx5/linux/mlx5_common_os.c
index c57e1918d2..b42102e84c 100644
--- a/drivers/common/mlx5/linux/mlx5_common_os.c
+++ b/drivers/common/mlx5/linux/mlx5_common_os.c
@@ -16,7 +16,7 @@
 #include <rte_errno.h>
 #include <rte_string_fns.h>
 #include <rte_bus_pci.h>
-#include <rte_bus_auxiliary.h>
+#include <bus_auxiliary_driver.h>
 
 #include "mlx5_common.h"
 #include "mlx5_nl.h"
diff --git a/drivers/common/mlx5/mlx5_common_private.h b/drivers/common/mlx5/mlx5_common_private.h
index 04c0af3763..12a5bdb41b 100644
--- a/drivers/common/mlx5/mlx5_common_private.h
+++ b/drivers/common/mlx5/mlx5_common_private.h
@@ -6,7 +6,7 @@
 #define MLX5_COMMON_PRIVATE_H
 
 #include <rte_pci.h>
-#include <rte_bus_auxiliary.h>
+#include <bus_auxiliary_driver.h>
 
 #include "mlx5_common.h"
 
diff --git a/drivers/net/mlx5/linux/mlx5_os.c b/drivers/net/mlx5/linux/mlx5_os.c
index 6899f430cb..62f654d18e 100644
--- a/drivers/net/mlx5/linux/mlx5_os.c
+++ b/drivers/net/mlx5/linux/mlx5_os.c
@@ -21,7 +21,7 @@
 #include <rte_pci.h>
 #include <bus_driver.h>
 #include <rte_bus_pci.h>
-#include <rte_bus_auxiliary.h>
+#include <bus_auxiliary_driver.h>
 #include <rte_common.h>
 #include <rte_kvargs.h>
 #include <rte_rwlock.h>